#pragma once
#include "PLQStatusApiPartialInterface.h"


// CAPIControl

class CAPIControl : public CWnd
{
	DECLARE_DYNAMIC(CAPIControl)

public:
	CAPIControl(void);
	virtual ~CAPIControl(void);

	bool InitInstance(void);
	void Exit(void);
	CString ReadMICR(EPBS_UINT8 bSelect, EPBS_UINT8 bFont, bool bSave);
	CString ReadStripe(EPBS_UINT32 dwFormat, EPBS_UINT32 dwDataType, bool bSave);
	void WriteStripe(EPBS_UINT32 dwFormat, EPBS_UINT32 dwDataType, LPCSTR lpWriteString);
	void ClearStripe(EPBS_UINT32 dwFormat, EPBS_UINT32 dwDataType);
	void ConfigureMICR(EPBS_UINT8 bSelect, EPBS_UINT8 bFont);
	void ConfigureMSRW(EPBS_UINT32 dwFormat, EPBS_UINT32 dwDataType);
	void SaveMICR(int nResult);
	void SaveMSR(int nResult, EPBS_UINT32 dwDetail, CString strStripeData);
	void GetStatus(EPBS_UINT32 dwStatusLength, EPBS_PUINT32 lpdwStatuses);

protected:
	DECLARE_MESSAGE_MAP()

protected:
	HINSTANCE	m_hLibrary;		// Module interface handle for PLQ-22 API
	int			m_nHandle;		// Handle used by PLQ-22 API
	bool		m_ErrFlag;		// Error flag
	MF_BASE01	m_tBase01;		// MF_BASE01 structure
	MF_MICR		m_tMicr;		// MF_MICR structure
	MF_MSRW		m_Msrw;			// MF_MSRW structure


	DLL_BiOpenMonPrinter				BiOpenMonPrinter;
	DLL_BiGetStatus						BiGetStatus;
	DLL_BiGetMultiStatus				BiGetMultiStatus;
	DLL_BiSetStatusBackFunction			BiSetStatusBackFunction;
	DLL_BiSetStatusBackFunctionEx		BiSetStatusBackFunctionEx;
	DLL_BiSetMultiStatusBackFunction	BiSetMultiStatusBackFunction;
	DLL_BiCancelStatusBack				BiCancelStatusBack;
	DLL_BiResetPrinter					BiResetPrinter;
	DLL_BiSCNMICRFunction				BiSCNMICRFunction;
	DLL_BiGetPrnCapability				BiGetPrnCapability;
	DLL_BiCloseMonPrinter				BiCloseMonPrinter;
	DLL_BiGetVersion					BiGetVersion;
	DLL_BiMICRClearSpaces				BiMICRClearSpaces;
	DLL_BiMSRWSetting					BiMSRWSetting;
	DLL_BiMSRWReadStripeData			BiMSRWReadStripeData;
	DLL_BiMSRWGetStripeData				BiMSRWGetStripeData;
	DLL_BiMSRWWriteStripeData			BiMSRWWriteStripeData;
	DLL_BiMSRWClearStripeData			BiMSRWClearStripeData;
	DLL_BiEjectPaper					BiEjectPaper;
	DLL_BiLockPort						BiLockPort;
	DLL_BiUnlockPort					BiUnlockPort;


	CString GetResultString(int nResultCode);
	CString GetRecordFormatString(EPBS_UINT32 dwRecordFormat);
	CString GetIBMDataTypeString(EPBS_UINT32 dwIBMDataType);
};


