#ifndef __SAMPLE_APP_H__
#define __SAMPLE_APP_H__

#include "DataManager.h"
#include "TwainInterface.h"
#include "TransferManager.h"
#include "SettingsDlg.h"
#include "SampleDlg.h"

#define		WM_ONACQUIRE		(WM_USER + 1)
#define		WM_XFERDATA			(WM_USER + 2)
#define		WM_ENDXFER			(WM_USER + 3)
#define		WM_SELECTSOURCE		(WM_USER + 4)
#define		WM_ONSETTINGS		(WM_USER + 5)

class SampleApp
{
public:
		SampleApp();
		virtual ~SampleApp();

		BOOL		Execute		(HINSTANCE hInstance);

private:
		BOOL		EventProc	(MSG* lpMsg);
		BOOL		StartUp		(HINSTANCE hInstance);
		BOOL		Acquire		(void);
		BOOL		DisableDS	(void);
		BOOL		CloseDS		(void);
		BOOL		CloseDSM	(void);
		int			MainLoop	(void);
		BOOL		SelectSource(pTW_STR32 pSrouceName);
		void		ChangeState	(void);

		HWND					m_hDlg;
		DataManager				*m_pDataManager;
		TwainInterface			*m_pTwainInterface;
		TransferManager			*m_pTransferManager;
		SampleDlg				*m_pSampleDlg;
};

BOOL SampleExecute(HINSTANCE hInstance);

#endif	// __SAMPLE_APP_H__
