#ifndef __TRANSFERMANAGER_H__
#define __TRANSFERMANAGER_H__

#include "DataManager.h"
#include "TwainInterface.h"

#define VALID_HANDLE    32      // valid windows handle SB >= 32

class TransferManager
{
public:
	TransferManager(HWND hDlg, DataManager *pDataManager, TwainInterface *pTwainInterface);
	virtual ~TransferManager(void);

private:
	HWND			m_hDlg;
	DataManager		*m_pDataManager;
	TwainInterface	*m_pTwainInterface;

	BOOL			m_bEnableMICR;
	BOOL			m_bEnableOCR;
	BOOL			m_bEnableBarcode;

	BOOL			CheckRecogCap			(TW_UINT16 cap);

	void			StoreRecogData			(void);
	void			ResetRecogData			(void);
	void			CheckEnableRecogData	(void);

public:
	void			NativeTransfer			(void);
	void			FileTransfer			(void);
	void			MemTransfer				(void);


};

#endif // __TRANSFERMANAGER_H__
